var url = new URL(window.location.href);
var plate = url.searchParams.get("plate");

if (plate != null) {
    document.getElementById("immatriculation").value = plate;
}

document.getElementById("send_button").addEventListener("click", function () {
    var famille = document.getElementById("familleVehicle").value;
    var vehicule = document.getElementById("vehicleType").value;
    var immatriculation = document.getElementById("immatriculation").value;

    if (famille == "" || vehicule == "" || immatriculation == "") {
        alert("Veuillez remplir tous les champs.");
        return;
    }

    // vérifier que la plaque d'immatriculation est bien au format français
    var regex = new RegExp("^[A-Z]{2}-[0-9]{3}-[A-Z]{2}$");
    if (!regex.test(immatriculation)) {
        alert("L'immatriculation doit être au format français (ex: AA-123-AA).");
        return;
    }
    var json = {
        famille: famille,
        vehicule: vehicule,
        immatriculation: immatriculation
    };
    console.log(json);
    var xhr = new XMLHttpRequest();
    xhr.open("POST", "http://localhost:3000/add_vehicle", true);
    xhr.setRequestHeader("Content-Type", "application/json");
    xhr.onreadystatechange = function () {
        if (xhr.readyState === 4 && xhr.status === 200) {
            if (xhr.responseText) {
                var response = JSON.parse(xhr.responseText);
                if (response.message == "Véhicule ajouté avec succès") {
                    window.location.href = "Vehicle.html?id=" + response.id;
                }
            } else {
                alert("Une erreur est survenue en tentant de récupérer les données.");
                console.error("error:", xhr.responseText);
            }
        } else if (xhr.readyState === 4 && xhr.status === 500) {
            var error = JSON.parse(xhr.responseText);
            if (error.message.includes("SQLITE_CONSTRAINT: UNIQUE constraint failed")) {
                alert("Une erreur est survenue en tentant d'ajouter le véhicule: L'immatriculation est déjà utilisée.");
            }
            else {
                alert("Une erreur est survenue en tentant de récupérer les données. (Plus d'informations dans la console)");
                console.error("error:", xhr.responseText);
            }
        }
    };
    xhr.send(JSON.stringify(json));
});