function callAPI(method, url, data, callback) {
    var xhr = new XMLHttpRequest();
    xhr.open(method, url, true);
    xhr.setRequestHeader("Content-Type", "application/json");
    xhr.onreadystatechange = function () {
        if (xhr.readyState == 4) {
            callback(xhr.responseText);
        }
    };
    xhr.send(data);
}

function insertData(id, value) {
    var element = document.getElementById(id);
    if (element) {
        let currentValue = 0;
        let targetValue = parseInt(value, 10);
        let increment = Math.ceil(targetValue / 200); // Slower animation by reducing increment

        function animateCounter() {
            currentValue += increment;
            if (currentValue >= targetValue) {
                currentValue = targetValue;
                element.innerHTML = currentValue;
            } else {
                element.innerHTML = currentValue;
                setTimeout(animateCounter, 20); // Add delay to slow down animation
            }
        }

        animateCounter();
    }
}

document.addEventListener('DOMContentLoaded', function () {
    callAPI('GET', 'http://localhost:3000/getindex', null, function (response) {
        console.log(response);
        var data = JSON.parse(response);
        insertData('vehicles_enregistres', data.vehicles);
        insertData('vehicles_familles', data.familles);
        insertData('vehicles_designations', data.designations);
        insertData('vehicles_types', data.vehiclestypes);

        var table = document.getElementById('table_mainpage');
        data.recentVehicles.forEach(function (vehicle) {
            var row = table.insertRow(-1);
            var cell1 = row.insertCell(0);
            var cell2 = row.insertCell(1);
            var cell3 = row.insertCell(2);
            var cell4 = row.insertCell(3);

            cell1.innerHTML = "<a href='vehicle.html?id=" + vehicle.id + "'>" + vehicle.immatriculation + "</a>";
            cell2.innerHTML = vehicle.numparc || 'Aucun';
            cell3.innerHTML = vehicle.vehicule || 'Aucun';
            cell4.innerHTML = new Date(vehicle.date).toLocaleDateString() + ' ' + new Date(vehicle.date).toLocaleTimeString();
        }
        );
    });
});