function callAPI(method, url, data, callback) {
    var xhr = new XMLHttpRequest();
    xhr.open(method, url, true);
    xhr.setRequestHeader("Content-Type", "application/json");
    xhr.onreadystatechange = function () {
        if (xhr.readyState == 4) {
            callback(xhr.responseText);
        }
    };
    xhr.send(data);
}

function insertData(id, value) {
    var element = document.getElementById(id);
    if (element) {
        element.value = value;
    }
}

// DELCARATION DES ID, avec correspondance table + colonne sql
const idToColumn = {
    "vehicle_famille": { table: "vehicles", column: "famille" },
    "vehicle_type": { table: "vehicles", column: "vehicule" },
    "immatriculation": { table: "vehicles", column: "immatriculation" },
    "agence": { table: "vehiclesProperties", column: "agence" },
    "numparc": { table: "vehicles", column: "numparc" },
    "fabrication_nacelle": { table: "vehiclesProperties", column: "numfabnacelle" },
    "numserie": { table: "vehiclesProperties", column: "numserie" },
    "miseencirculation": { table: "vehiclesProperties", column: "firstmiseencirculation" },
    "pneumatiques": { table: "vehiclesProperties", column: "pneumatiques" },
    "pneumatiques_av": { table: "vehiclesProperties", column: "pressionavant" },
    "pneumatiques_ar": { table: "vehiclesProperties", column: "pressionarriere" },
    "filtre_huile": { table: "vehiclesFilters", column: "huile" },
    "filtre_gazole": { table: "vehiclesFilters", column: "gazole" },
    "filtre_air": { table: "vehiclesFilters", column: "air" },
    "filtre_habitacle": { table: "vehiclesFilters", column: "habitacle" },
    "filtre_hydraulique": { table: "vehiclesFilters", column: "hydraulique" },
    "huile_moteur": { table: "vehiclesFiltersHuile", column: "moteur" },
    "huile_moteur_type": { table: "vehiclesFiltersHuile", column: "moteur_type" },
    "huile_moteur_quantite": { table: "vehiclesFiltersHuile", column: "moteur_quantite" },
    "huile_bv": { table: "vehiclesFiltersHuile", column: "bv" },
    "huile_bv_type": { table: "vehiclesFiltersHuile", column: "bv_type" },
    "huile_bv_quantite": { table: "vehiclesFiltersHuile", column: "bv_quantite" },
    "huile_pont": { table: "vehiclesFiltersHuile", column: "pont" },
    "huile_pont_type": { table: "vehiclesFiltersHuile", column: "pont_type" },
    "huile_pont_quantite": { table: "vehiclesFiltersHuile", column: "pont_quantite" },
    "huile_direction": { table: "vehiclesFiltersHuile", column: "direction" },
    "huile_direction_type": { table: "vehiclesFiltersHuile", column: "direction_type" },
    "huile_direction_quantite": { table: "vehiclesFiltersHuile", column: "direction_quantite" },
    "huile_hydraulique": { table: "vehiclesFiltersHuile", column: "hydraulique" },
    "huile_hydraulique_type": { table: "vehiclesFiltersHuile", column: "hydraulique_type" },
    "huile_hydraulique_quantite": { table: "vehiclesFiltersHuile", column: "hydraulique_quantite" },
    "pv": { table: "vehiclesTare", column: "pv" },
    "ptac": { table: "vehiclesTare", column: "ptac" },
    "ptra": { table: "vehiclesTare", column: "ptra" },
    "ixl": { table: "vehiclesTare", column: "ixl" },
    "s": { table: "vehiclesTare", column: "s" },
    "chargemaxi": { table: "vehiclesTare", column: "chargemaxi" },
    "hauteurmaxi": { table: "vehiclesTare", column: "hauteurmaxi" },
    "placesassises": { table: "vehiclesTare", column: "placesassises" },
    "chargemaxitractable": { table: "vehiclesTare", column: "chargemaxitractable" },
    "car": { table: "vehiclesTare", column: "car" },
    "numcle": { table: "vehiclesTare", column: "numcle" },
    "electronic_code": { table: "vehiclesTare", column: "electroniccode" },
    "mechanical_code": { table: "vehiclesTare", column: "mechanicalcode" },
};

// toute les 5sec, grouper les données et les envoyer au serveur
setInterval(function () {
    // si la page est active
    if (document.hidden) {
        return;
    }
    document.getElementById("alert_top").classList.remove("alert-success");
    document.getElementById("alert_top").classList.add("alert-warning");
    document.getElementById("alert_text").innerHTML = "Enregistrement en cours...";
    var data = {};
    var i = 0;
    for (var id in idToColumn) {
        var element = document.getElementById(id);
        if (element) {
            data[i] = {
                table: idToColumn[id].table,
                column: idToColumn[id].column,
                value: element.value || JSON.stringify(element.innerHTML)
            }
            i++;
        }
    }

    // lot de bord
    var checkboxes = document.querySelectorAll("input[type=checkbox][id^=lot_bord_]");
    var data_checkbox = {};
    for (var i = 0; i < checkboxes.length; i++) {
        data_checkbox[i] = {
            id: checkboxes[i].id,
            value: checkboxes[i].checked
        }
    }
    data[i + 1] = {
        table: "vehiclesLotDeBord",
        column: "options",
        value: JSON.stringify(data_checkbox)
    }

    // outillage de bord
    var divoutillage = document.getElementById("outillage_bord");
    data[i + 2] = {
        table: "vehiclesOutillage",
        column: "text",
        value: JSON.stringify(quill.getContents())
    }

    callAPI("POST", "http://localhost:3000/update_vehicle", JSON.stringify(data), function (response) {
        document.getElementById("alert_top").classList.remove("alert-warning");
        document.getElementById("alert_top").classList.add("alert-success");
        document.getElementById("alert_text").innerHTML = "Toutes les modifications ont été enregistrées ! Dernière sauvegarde : " + new Date().toLocaleTimeString();
    });
}, 5000);

document.addEventListener("DOMContentLoaded", function () {
    var url = new URL(window.location.href);
    var id = url.searchParams.get("id");

    if (id) {
        callAPI("POST", "http://localhost:3000/get_full_vehicle", JSON.stringify({ id: id }), function (response) {
            if (response === "") {
                window.location.href = "index.html";
                return;
            }
            const rep = JSON.parse(response);
            for (var key in rep) {
                insertData(key, rep[key]);
            }
            document.getElementById("vehicle_top_page").innerHTML = "Véhicule : " + rep["immatriculation"] + " - " + rep["vehicle_type"];

            // lot de bord
            var data = JSON.parse(rep["lot_de_bord"]);
            for (var key in data) {
                var element = document.getElementById(data[key].id);
                if (element) {
                    if (data[key].value) {
                        element.checked = true;
                    }
                    else {
                        element.checked = false;
                    }
                }
            }

            // outillage de bord
            quill.setContents(JSON.parse(rep["outillage"]));
        });

        // designations
        callAPI("POST", "http://localhost:3000/get_designations", JSON.stringify({ id: id }), function (response) {
            response = JSON.parse(response);
            console.log(response);
            var table = document.getElementById("table_designations");
            response.forEach(function (element, index) {
                var row = table.insertRow(-1);
                var cell1 = row.insertCell(0);
                var cell2 = row.insertCell(1);
                var cell3 = row.insertCell(2);
                var cell4 = row.insertCell(3);
                var cell5 = row.insertCell(4);
                var cell6 = row.insertCell(5);

                cell1.innerHTML = `<input class="form-control" type="date" value="${element.date}">`;
                cell2.innerHTML = `<input type="number" class="form-control" min="0" step="1" value="${element.kilometre}">`;
                cell3.innerHTML = `<input type="number" class="form-control" step="1" min="0" value="${element.heure}">`;
                cell4.innerHTML = `<select class="form-control">
                        <option value="option0" ${element.designation === "Aucun" ? "selected" : ""}></option>
                        <option value="option1" ${element.designation === "Révision" ? "selected" : ""}>Révision</option>
                        <option value="option2" ${element.designation === "Atelier" ? "selected" : ""}>Atelier</option>
                        <option value="option3" ${element.designation === "Véhicule sorti de l'atelier disponible pour la location" ? "selected" : ""}>Véhicule sorti de l'atelier disponible pour la location</option>
                        <option value="option4" ${element.designation === "Commande pièce(s)" ? "selected" : ""}>Commande pièce(s)</option>
                        <option value="option5" ${element.designation === "Commande pièce(s) en attente de livraison ou de montage" ? "selected" : ""}>Commande pièce(s) en attente de livraison ou de montage</option>
                        <option value="option6" ${element.designation === "Contrôle pollution" ? "selected" : ""}>Contrôle pollution</option>
                        <option value="option7" ${element.designation === "Contrôle pollution avec contre visite" ? "selected" : ""}>Contrôle pollution avec contre visite</option>
                        <option value="option8" ${element.designation === "Contrôle technique ( toutes les observations relevées )" ? "selected" : ""}>Contrôle technique ( toutes les observations relevées )</option>
                        <option value="option9" ${element.designation === "Contrôle technique avec observation(s) mineur(s) à résoudre dès que possible" ? "selected" : ""}>Contrôle technique avec observation(s) mineur(s) à résoudre dès que possible</option>
                        <option value="option10" ${element.designation === "Contrôle technique avec contre visite défaut(s) majeur(s) ou défaut(s) critique(s)" ? "selected" : ""}>Contrôle technique avec contre visite défaut(s) majeur(s) ou défaut(s) critique(s)</option>
                        <option value="option11" ${element.designation === "Essai routier ou transfert du véhicule" ? "selected" : ""}>Essai routier ou transfert du véhicule</option>
                        </select>`;
                cell5.innerHTML = `<div id="editor-work-${index}"></div>`;
                var quillEditor = new Quill(`#editor-work-${index}`, {
                    modules: {
                        toolbar: fullOptions
                    },
                    theme: 'snow'
                });
                quillEditor.setContents(JSON.parse(element.details || '{}'));
                cell6.innerHTML = `<button class="btn btn-success" onclick="saveDesignation(${element.id}, ${index})"><i class="fas fa-save"></i></button>` +
                    `<button class="btn btn-danger" onclick="deleteDesignation(${element.id})"><i class="fas fa-trash"></i></button>`;
            });
        });
    } else {
        window.location.href = "index.html";
    }
});

document.body.addEventListener('click', function (e) {
    // Vérifier si l'élément cliqué est une image dans un éditeur Quill
    if (e.target.tagName.toLowerCase() === 'img' && e.target.closest('[id^="editor-work-"]')) {
        const imgSrc = e.target.src;
        console.log(imgSrc);
    }
});

function saveDesignation(id, index) {
    console.log(id, index);
};

function deleteDesignation(id) {
    console.log(id);
};


document.getElementById("button_add_design").addEventListener("click", function () {
    document.getElementById("date-modal-add").value = new Date().toISOString().split("T")[0];
    document.getElementById("km-modal-add").value = "";
    document.getElementById("hours-modal-add").value = "";
    quillAddWork.setContents([{ insert: '\n' }]);
});

document.getElementById("save-modal-add").addEventListener("click", function () {
    const url = new URL(window.location.href);
    const id = url.searchParams.get("id");
    var date = document.getElementById("date-modal-add").value;
    var kilometres = document.getElementById("km-modal-add").value;
    var heures = document.getElementById("hours-modal-add").value;
    var typemodaladd = document.getElementById("type-modal-add").value;
    var designation = quillAddWork.getContents();
    var json = {
        id: id,
        date: date,
        kilometres: kilometres,
        heures: heures,
        typemodaladd: typemodaladd,
        designation: JSON.stringify(designation)
    };
    callAPI("POST", "http://localhost:3000/add_designation", JSON.stringify(json), function (response) {
        response = JSON.parse(response);
        if (response.message === "OK") {
            window.location.reload();
        }
    });
});