from flask import Flask, send_from_directory
import os

app = Flask(__name__)

# Route pour servir les fichiers statiques (CSS, JS, etc.)
@app.route('/assets/<path:filename>')
def serve_assets(filename):
    # Affiche le répertoire d'actuels fichiers pour vérifier le chemin
    print(f"Request for: {filename}")
    
    assets_path = os.path.join(os.getcwd(), 'assets')
    
    # Vérifier si le fichier existe avant de le servir
    file_path = os.path.join(assets_path, filename)
    if not os.path.exists(file_path):
        print(f"File not found: {file_path}")
        return "File not found", 404  # Renvoie une erreur 404 si le fichier n'existe pas

    # Si le fichier existe, il est envoyé
    print(f"Serving file: {file_path}")
    return send_from_directory(assets_path, filename)

@app.route('/API/<path:filename>')
def serve_api_files(filename):
    api_path = os.path.join(os.getcwd(), 'API')
    return send_from_directory(api_path, filename)

# Route pour servir l'index.html
@app.route('/')
def index():
    return send_from_directory(os.getcwd(), 'index.html')

# Route pour servir l'index.html
@app.route('/index.html')
def index_html():
    return send_from_directory(os.getcwd(), 'index.html')

@app.route('/vehicle.html')
def vehicle_html():
    return send_from_directory(os.getcwd(), 'vehicle.html')

if __name__ == '__main__':
    app.run(host='0.0.0.0', port=1234)
